<?php

/**

*    Main class to interact with Diigo API.

*

*    @category   PHP

*    @package    diigosilo

*    @author     Pierre-Yves Gillier <pivwan@gmail.com>

*    @copyright  2008 Pierre-Yves Gillier

*    @license    http://www.apache.org/licenses/LICENSE-2.0.txt  Apache Software Licence 2.0

*    @version    0.1

*    @link       http://www.pivwan.net/weblog/plugin-diigosilo

*/

include_once(dirname(__FILE__).'/httpClient.class.php');

class DiigoAPISyndicate

{

	private $username;

	private $password;

	private $httpClient;	

	private $key ; //= 'c07e6d208a7a0098';

	const API_URI = "api2.diigo.com";

	public function __construct($username,$password , $apikey)

	{

		// Get credentials

		$this->username = $username;

		$this->password = $password;

		$this->key = $apikey;

		// Init httpClient

		$this->httpClient = new HttpClient(self::API_URI);

		$this->httpClient->setUserAgent("Diigo Silo for Habari/");

		$this->httpClient->setAuthorization($this->username,$this->password ,$this->key);

		if(defined('UNITTESTING'))

			$this->httpClient->setDebug(true);

	}

	public  function saveBookmarks($url , $title )

	{

		$attachment = array ("url" => $url, "title" => $title , "shared" => "yes" );

		$url_curl = 'https://secure.diigo.com/api/v2/bookmarks?key='.$this->key;

		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL,$url_curl);

		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);

		curl_setopt($ch, CURLOPT_USERPWD, $this->username . ":" . $this->password );

		curl_setopt($ch, CURLOPT_POST, true);

		curl_setopt($ch, CURLOPT_POSTFIELDS, "url=$url&title=$title&shared=yes");

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  //to suppress the curl output 

		$result = curl_exec($ch);

		

		curl_close ($ch);

	}

	public function getTags()

	{

	}

	public function getBookmarks()

	{

		$params = array('key' => $this->key, 'users' => $this->username );

		

		if($this->httpClient->get("/bookmarks",$params)==true)

		{

			return $this->parseJSON($this->httpClient->getContent());

		}

		else

		{

			throw new Exception("WGET:"+$this->httpClient->getError());

		}

	}

	private function parseJSON($json)

	{

		if (!extension_loaded('json'))

		{

			include_once(dirname(__FILE__).'/JSON.class.php');

			$json = new JSON;

			$objs = $json->unserialize($json);

		}

		else

		{

			$objs = json_decode($json);

		}

		return($objs);

	}

}

?>